//#########################################################################
// 
//       World MAP  v  0.7
//   
//          Main Program
//   
//      Created 24/10/2002; 15:33:40
//
//           By David Coz  
//
//       Coz.hubert@infonie.fr
//
//  WebSite : http://membres.lycos.fr/dcoz
//
//##########################################################################



#define USE_TI92PLUS

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define NO_CALC_DETECT

#define NO_EXIT_SUPPORT

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"         // Graphic Library
#include "map2.h"             // Map Binary
#include "info.h"             // All the country information

#define LE  69                // Map Length  ( 8 pixel trunc => 69*8 pixels ) 
#define HI  42                // Map Width   ( 8 pixel trunc => 42*8 pixels )
#define CURS_SP 10            // Cursor Speed (on,off)

// Constants for the different Display Mode :

#define NORMAL 0      // scrolling the map
#define MENU   1      // Country Selection Menu
#define INFO   2      // Country Informations are displayed


// DEC = 0 for TI89 , 1 for TI92PLUS
#ifdef USE_TI89
#define DEC 0
#endif
#ifndef USE_TI89
#define DEC 1
#endif


//virtual screens = light and dark
void *vscreen1,*vscreen2;

int x_curs,y_curs; // cursor position
int country;       // country number (0 to 177) 
int mode;          // current mode (see above)

long int time,delay,release;


/* Country Informations are displayed*/
void info()
{

int i,j,x0,y0,x1,y1,st,end;

// black,dark,light,white
char color[4]={8,4,2,1};

// Main rectangle coordinates (depends on the Calc )

x0 = 20 + DEC*30;
y0 = 15 + DEC*8;
x1 = 139 + DEC*50;
y1 = 84 + DEC*15;

// Draw the rectangle with its border
for (i=0;i<4;i++)
DrawGrayRect2B( x0+i, y0+i-9 , x1-i , y1-i , color[i] , i==3 ? 1:0 , vscreen1 , vscreen2 );

FontSetSys(F_6x8);

// Upper Border in dark
DrawGrayRect2B(x0+3,y0-6,x1-3,y0+1,4,1,vscreen1,vscreen2);
FontSetSys(F_4x6);

// Informations....

DrawStr(x0+8,y0-5,"General Informations...",A_XOR);

DrawStr(x0+8+DEC*5,y0+10+DEC*2,"Country : ",A_XOR);

DrawStr(x0+50+DEC*5,y0+10+DEC*2,country_name[country],A_NORMAL);

FontSetSys(F_4x6);

DrawStr(x0+8+DEC*5,y0+20+DEC*3,"Capital : ",A_XOR);

DrawStr(x0+50+DEC*5,y0+20+DEC*3,capital_name[country],A_XOR);

printf_xy(x0+8+DEC*5,y0+30+DEC*4,"Pop. : %ld thd" , (long)infos[country][1]*100);

printf_xy(x0+8+DEC*5,y0+40+DEC*5,"Area : %ld thd sq km" ,(long)infos[country][0]);

printf_xy(x0+8+DEC*5,y0+50+DEC*6,"GNP : %ld" , (long)infos[country][2]*10);

}



// Country Selection Menu

void menu()
{

int i,j,x0,y0,x1,y1;

// 7 countries are displayed at a time ...
//first country displayed(up)
int st=country-3;
// last country displayed
int end=country+3;

// black,dark,light,white
char color[4]={8,4,2,1};

// Some 'out-of-range' adjustment 
if (st < 0)
{
st = 0;
end = 6;
}
if (end > 177)
{
end = 177;
st = 171;
}

// Main rectangle coordinates (depends on the Calc )

x0 = 20 + DEC*30;
y0 = 10 + DEC*8;
x1 = 139 + DEC*50;
y1 = 89 + DEC*15;


// Draw the rectangle with its border
for (i=0;i<4;i++)
DrawGrayRect2B( x0+i , y0+i-9 , x1-i , y1-i , color[i] , i==3 ? 1:0 ,vscreen1,vscreen2);

// Upper Border in dark
DrawGrayRect2B( x0+3 , y0-6 , x1-3, y0+1 , 4 , 1 ,vscreen1,vscreen2);
FontSetSys(F_4x6);

DrawStr(x0+8,y0-5,"Select a country...",A_XOR);

// Huge font on Ti92+ , normal for ti89
if (DEC)
FontSetSys(F_8x10);
else
FontSetSys(F_6x8);

// display the 7 seven country names
for (i=st;i<end+1;i++)
DrawStr(x0+8+DEC*5,y0+5+(i-st)*(10+DEC),country_name[i],A_NORMAL);

// the selected one is grayed 
InvertGrayRect2B(x0+5,y0+4+(country-st)*(10+DEC),x1-5,y0+13+DEC+(country-st)*(10+DEC),vscreen1,vscreen2);

}



// Map display
void drawmap(int x,int y)
{

delay++;
// cursor sprite
static char curseur[8] = {0x70,0xF8,0xD8,0xF8,0x70,0x00,0x00,0x00};
int i,j;

time++;
release++;

// map offset , depending on the position
int offset = 8 * y * LE + x ;

// copy 90 ( 118 on ti92+) map binary rows (30 bytes each) in the screen buffers  
for (i=0 ; i< 90+DEC*28 ; i++)
{
memcpy( vscreen1 + i*30 , light_map + offset + i*LE , 30);
memcpy( vscreen2 + i*30 , dark_map  + offset + i*LE , 30);
}
// clear the last 10 pixel rows , so as to display the current country name 
memset( vscreen2 + 90*30 + DEC*28*30 , 0 , 30*10);
memset( vscreen1 + 90*30 + DEC*28*30 , 0 , 30*10);

FontSetSys(F_6x8);

//current country name
DrawStr(10+DEC*10,91+DEC*28,"Country :",A_NORMAL); 
DrawStr(70+DEC*30,91+DEC*28,country_name[country],A_NORMAL); 

// If the current country position in on the screen , display its capital localisation

if ( x_curs-x*8 < 240 && x_curs > x*8 && y_curs>y*8 && y_curs-y*8 < 90+DEC*28 )
{
	// on off effect , the sprite is diplayed half the time
	if ( time < CURS_SP )
	Sprite8( (x_curs-(x*8)) - 2 , (y_curs-(y*8))-2 , 5 , curseur , vscreen2 , SPRT_XOR );
	if (time > 2*CURS_SP)
	time=0;
}

// handle the different modes
if (mode==MENU)
menu(); //country selection

if (mode==INFO)
info(); // country informations

// At last , copy the Virtual Screen into the Real Screen
memcpy( GetPlane(0) , vscreen1 , 3840);
memcpy( GetPlane(1) , vscreen2 , 3840);

}




//country localzation (roughly its capital) must be in the screen center 
   
void update(int *x,int *y)
{
x_curs = (capital_pos[2*country+1]>>1)-11;
y_curs = capital_pos[2*country+0]>>1;

*x=(x_curs>>3)-10-DEC*5;
*y=(y_curs>>3)-5-DEC*3;

if ( *x<0 )
*x=0;
if ( *x>= LE-20-DEC*10 )
*x = LE-20-DEC*10;

if (*y<0)
*y=0;

if (*y>=HI-11-DEC*4)
*y=HI-11-DEC*4;

}



// handle the character selection : 'a','b',...
void char_key()
{
int code=-1;

#ifdef USE_TI89
if (_rowread(~((short)(1<<5))) & (1<<4)) // Equals
code=65;
if (_keytest(RR_PAREN_OPEN))
code=66;
if (_keytest(RR_PAREN_CLOSE))
code=67;
if (_keytest(RR_COMMA))
code=68;
if (_keytest(RR_DIVIDE))
code=69;
if (_keytest(RR_WITH))
code=70;
if (_keytest(RR_7))
code=71;
if (_keytest(RR_8))
code=72;
if (_keytest(RR_9))
code=73;
if (_keytest(RR_MULTIPLY))
code=74;
if (_keytest(RR_EE))
code=75;
if (_keytest(RR_4))
code=76;
if (_keytest(RR_5))
code=77;
if (_keytest(RR_6))
code=78;
if (_keytest(RR_MINUS))
code=79;
if (_keytest(RR_STORE))
code=80;
if (_keytest(RR_1))
code=81;
if (_keytest(RR_2))
code=82;
if (_keytest(RR_3))
code=83;
if (_keytest(RR_T))
code=84;
if (_keytest(RR_PLUS))
code=85;
if (_keytest(RR_0))
code=86;
if (_keytest(RR_DOT))
code=87;
if (_keytest(RR_X))
code=88;
if (_keytest(RR_Y))
code=89;
if (_keytest(RR_Z))
code=90;
#endif

#ifndef USE_TI89  // on ti92+ and V200

if (_keytest(RR_A))
code=65;
if (_keytest(RR_B))
code=66;
if (_keytest(RR_C))
code=67;
if (_keytest(RR_D))
code=68;
if (_keytest(RR_E))
code=69;
if (_keytest(RR_F))
code=70;
if (_keytest(RR_G))
code=71;
if (_keytest(RR_H))
code=72;
if (_keytest(RR_I))
code=73;
if (_keytest(RR_J))
code=74;
if (_keytest(RR_K))
code=75;
if (_keytest(RR_L))
code=76;
if (_keytest(RR_M))
code=77;
if (_keytest(RR_N))
code=78;
if (_keytest(RR_O))
code=79;
if (_keytest(RR_P))
code=80;
if (_keytest(RR_Q))
code=81;
if (_keytest(RR_R))
code=82;
if (_keytest(RR_S))
code=83;
if (_keytest(RR_T))
code=84;
if (_keytest(RR_U))
code=85;
if (_keytest(RR_V))
code=86;
if (_keytest(RR_W))
code=87;
if (_keytest(RR_X))
code=88;
if (_keytest(RR_Y))
code=89;
if (_keytest(RR_Z))
code=90;
#endif

// code = -1 if no char key was pressed, 
// else contains the ASCII code of the letter :
// A = 65 , B = 66 , .......  Z = 90 

if (code!=-1)
{
	// look for a conutry with the wanted first letter....
	country=0;
	// country_name[country][0] = contry first letter code...
	while ( country_name[country][0] < code )
  	country++;
}

}




// Handle key presses
int key(int *x,int *y)
{

// Right is pressed
if (_keytest(RR_RIGHT))
{

	if (mode==INFO)
	mode=NORMAL; // shift from INFO to NORMAL

if (mode==NORMAL) // map scrolling
 {
	if (*x<LE-20-DEC*10) // increase x_position 
	(*x)++; 
  }
 }

// Left is pressed
if (_keytest(RR_LEFT))
{
	if (mode==INFO)
	mode=NORMAL; // shift from INFO to NORMAL

if (mode==NORMAL) // map scrolling
	{
 if (*x!=0)  // decrease x_position
  (*x)--;
   }
}

// if in contry selection , handle the 'alpha' keys 
if (mode==MENU)
char_key();

// Down is pressed
if (_keytest(RR_DOWN))
	{
	if (mode==INFO)
	mode=NORMAL; // shift from INFO to NORMAL
	
			if (mode==NORMAL)// map scrolling
			{
			 if (*y < HI-12-DEC*4 ) // increase y_position 
			 (*y)++;
			}
			else if (mode==MENU) // country selection
			 {
			   country++; // increase country selected

			   if (!DEC&&_keytest(RR_2ND))  // fast browsing by pressing on 2nd (Hand) 
			   country+=9;
			   if (DEC&&_keytest(RR_HAND))
         country+=9;
         
         if (country>=177) // out of range test
			    country=177;
			 }
	}

// Up is pressed
if (_keytest(RR_UP))
	{
	if (mode==INFO)
	mode=NORMAL;  //shift from INFO to NORMAL
	
	if (mode==NORMAL) // map scrolling
			{
			 if (*y!=0)  
			 (*y)--;    // decrease y_position 
			}
			else if (mode==MENU)  // country selection
			 {
			 country--;   // decrease country selected
			   
			   if (!DEC&&_keytest(RR_2ND)) // fast browsing by pressing on 2nd (Hand)
			   country-=9;
			   if (DEC&&_keytest(RR_HAND))
         country-=9;
  
			   if (country<0)  // out of range test
			    country=0;
			 }
  
  }

// country selection
if (_keytest(RR_APPS))
mode=MENU;  


if (_keytest(RR_ENTER))
{
	if ( mode == NORMAL ) // on the Map
	{
		if ( delay > 20 )
		{
		// shift to INFO mode
		mode = INFO;
		release = 0;
		}
  }
  else if ( release > 5 )
  {
    // shift back to NORMAL mode
	  mode = NORMAL; 
	  update( x , y ); // new country localzation 
	  delay = 0; 
  }
}
  
if 	(_keytest(RR_ESC))
{
	if (mode==NORMAL)
	return 0; // exit
	else
	mode = NORMAL; // shift back to NORMAL mode
	delay=0;
}
return 1;
}



// Main Function
void _main(void)
{
LCD_BUFFER screen;
LCD_save(screen);

if (DEC)
FontSetSys(F_8x10);
else
FontSetSys(F_6x8);

// first country selected is France :)
country = 55 ;

x_curs = (capital_pos[2*country+1]>>1)-11;
y_curs = capital_pos[2*country+0]>>1;

mode = NORMAL;
ClrScr();

// memory allocation...
vscreen1 = malloc(3840);
vscreen2 = malloc(3840);

// if you're short of memory ...
if ( vscreen1 == NULL || vscreen2 == NULL )
{
  if (vscreen1 != NULL)
   free(vscreen1);
  if (vscreen2 != NULL)
   free(vscreen2);
	   
	LCD_restore(screen);
	
	ST_showHelp("Out of memory..."); 
}


memset(vscreen1,0,3840);
memset(vscreen2,0,3840);

int x=0,y=0;

// Disable AUTO_INT_1 (we'll use rowread)
INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER); 

time = 0;
delay = 0;
release = 0;

GrayOn();

// we'll display informations on Vscreen2 (dark plane)
PortSet(vscreen2,239,127);

// first country position
update( &x , &y );

// Main Loop :

while ( key(&x,&y) )
drawmap(x,y);

GrayOff();

// Clean up stuff...
free(vscreen1);
free(vscreen2);
PortRestore();

SetIntVec (AUTO_INT_1, save_int_1);

LCD_restore(screen);

ST_showHelp(" *WorldMap* v 0.7 by David Coz"); 

}
